2021-03-23  Karl Berry  <karl@tug.org>

	* TL'21.

2021-02-18  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* eptex.ech, eptex_version.h: e-pTeX version 210118 for TL21.

2020-11-29  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* fam256.ch: Adapt to changes in ptex-base.ch.

2020-09-01  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* pdfutils.ch (Scan the argument for command |c|) <expanded_code>:
	free_avail(def_ref) to avoid memory exhaustion with many \expanded.
	(Sync with pdftex.web and xetex.web changes r56230.)

2020-07-19  Karl Berry  <karl@freefriends.org>

	* char-warning-eptex.ch: new file (see ../pdftexdir/ChangeLog).
	* am/eptex.am (eptex_ch_srcs): add it.

2020-05-05  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* pdfutils.ch: Sync with inhibit_glue_flag improvement.
	https://github.com/texjporg/tex-jp-build/pull/102

2019-12-10  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* am/eptex.am (eptex_CPPFLAGS): append $(ZLIB_INCLUDES).
	(eptex_LDADD): append $(ZLIB_LIBS.)
	(eptex_DEPENDENCIES): append $(ZLIB_DEPEND) 
	(eptex_web_srcs): append zlib-fmt.ch.

2019-11-12  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* pdfutils.ch: Add primitives \Uchar and \Ucharcat.
	* tests/uchar.tex: Added.
	* eptex.ech, eptex_version.h: e-pTeX version 191112.

2019-10-28  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* eptex.ech: Add primitives \current(x)spacingmode.

2019-09-08  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* eptex.ech: \readline correctly handles Japanese characters.

2019-07-21  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* eptex.ech: More compatible with original e-TeX, because
	'\fontchar??' and '\iffontchar' for Latin font is effective
	only for 0--255.

2019-07-09  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* pdfutils.ch: Add primitive \ifincsname.
	* eptex.ech: Revise \iffontchar and \fontchar?? to treat
	negative value as char_type.
	  - \iffontchar (Japanese font f) (number c):
	    - c >= 0: true iff is_char_kanji(c)
	    - c < 0: true iff f has char_type -(c+1)
	  - \fontcharwd (Japanese font f) (number c):
	    - c >= 0: return the width of character c
	    - c < 0: return the width of char_type -(c+1)
	* tests/fontchar.{sh,tex}, tests/zero_search.tex: Added.
	* eptex.ech, eptex_version.h: e-pTeX version 190709.

2019-05-28  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* am/eptex.am: Add a new test.
	* epver.test: New test file for version number consistency.

2019-04-02  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* eptex.ech: \fontcharwd etc. for Japanese fonts correctly
	returns a dimension for all kanji codes.

2019-03-01  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* eptex.ech: Fix \show\savinghyphcodes. (Bug introduced in
	2018-09-01).

2019-01-31  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* pdfutils.ch: Improve \pdfsavepos when papersize special
	at the middle of shipout procedure is involved.
	Pointed out by N. Abe.
	https://oku.edu.mie-u.ac.jp/tex/mod/forum/discuss.php?d=2564
	* tests/pdfsavepos.tex: Added.

2019-01-23  Hironobu Yamashita  <h.y.acetaminophen@gmail.com>

	* eptex.defines: Add dumpkanji and undumpkanji.

2018-09-09  Karl Berry  <karl@tug.org>

	* eptriptest.test,
	* pdfprimitive.test: LC_ALL=LANGUAGE=C.

2018-09-01  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* eptex.ech, pdfutils.ch: New primitive \readpapersizespecial.
	* eptex.ech, eptex_version.h: e-pTeX version 180901.
	* tests/pdforigin.tex, tests/pdfpagewidth.tex: Added.

2018-05-18  Joseph Wright  <joseph.wright@morningstar2.co.uk>
            Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* eptex-base.ch, pdfutils.ch: New primitive \expanded
	* eptex.ech, eptex_version.h: e-pTeX version 180518.

2018-03-24  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>
            Hironobu Yamashita <h.y.acetaminophen@gmail.com>

	* etex.ch1: Recover the right \lastnodesubtype initialization
	value ignored by tex.ch.
	* eptex.ech: Describe \lastnodesubtype.

2018-02-26  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* eptex.ech, eptex_version.h: e-pTeX version 180226.

2018-02-25  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* eptex.ech: New primitive \lastnodesubtype.

2018-01-21  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* eptex.ech, etex.ch0, etex.ch1, pdfutils.ch: New primitive \epTeXversion.
	* eptex.ech, eptex_version.h: e-pTeX version 180121.

2017-12-22  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* fam256.ch: \delcode defaults to -1, not -4097, to be compatible
	with TeX82. Correct assignment of negative \delcode.

2017-12-15  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* pdfutils.ch: Fix a error message "! File ended while ..."
	while \pdfstrcmp, \pdfmdfivesum, etc. are used.

2017-12-13  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* fam256.ch: \show\odelimiter should be \odelimiter, etc.

2017-11-30  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* pdfutils.ch: \pdfprimitive gives no error if argument is not a
	primitive, just do nothing. (Synchronized pdftex r784, tl r45936)
	* tests/pdfprimitive-test.tex, tests/pdfprimitive-eptex.log:
	Add more tests for \pdfprimitive.

2017-10-06  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* pdfutils.ch: Merge prim_eqtb into eqtb, to avoid a bug in
	the use of \pdfprimitive inside vertical mode.
	* tests/pdfprimitive-test.tex, tests/pdfprimitive-eptex.log:
	Add more tests for \pdfprimitive.

2017-09-24  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* pdfutils.ch: Avoid overwriting prim_* entries by primitive().
	* eptex.ech, eptex_version.h: Change version to 170924.

2017-09-09  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>
	and Noriyuki Abe  <abenori@math.sci.hokudai.ac.jp>

	* eptex.ech: \epTeXinputencoding works also with the terminal.
	* eptex.defines: Add a new function setstdinenc().

2017-09-06  Noriyuki Abe  <abenori@math.sci.hokudai.ac.jp>

	* eptex.ech: fix a bug in \epTeXinputencoding.

2017-04-24  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* eptex.ech, etex.ch1, euptex.ch0, pdfutils.ch:
	Adapt to changes in ptexdir/ptex-base.ch (p\TeX -> \pTeX).

2016-12-15  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* eptexextra.h: Use "issue@texjp.org" as BUG_ADDRESS.

2016-11-14  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* eptex.ech, eptex_version.h, pdfutils.ch: Add new primitives
	\pdfuniformdeviate, \pdfnormaldeviate, \pdfrandomseed, \pdfsetrandomseed,
	\pdfelapsedtime, \pdfresettimer.

2016-10-31  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* pdfutils.ch: Remove an unused variable to avoid a compiler warning.

2016-10-30  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* eptex.defines, eptex.ech, eptex_version.h, pdfutils.ch:
	Use initstarttime() to improve CreationDate.

2016-09-12  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* eptex.ech, pdfutils.ch: Realize better box in math mode.

2016-09-06  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* fam256.ch: Allow only 8bit arguments for \catcode etc.

2016-07-29  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* pdfutils.ch: Improve \pdfsavepos as pointed out by N. Abe.

2016-03-04  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* etex.ch1: Adapt to changes in ptexdir/ptex-base.ch.

2016-02-01  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* eptex.ech: Add a new primitive \epTeXinputencoding. (from N. Abe).
	Change version to 160201 (H. Kitagawa).
	* eptex.defines: Add a new function setinfileenc() for a new primitive
	\epTeXinputencoding. (from N. Abe).
	* eptex_version.h: Change version to 160201 (H. Kitagawa).

2015-09-22  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* eptriptest.test: Also check tripos.tex and etrip.out.

2015-08-06  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pdfprimitive.test: New shell script testing \pdfprimitive.
	* tests/pdfprimitive-test.tex tests/pdfprimitive-eptex.log:
	New test input and expected output data.
	* am/eptex.am: Added the new files.

2015-08-05  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* pdfutils.ch: Add primitives \pdfprimitive and \ifpdfprimitive 
	to e-(u)pTeX.
	* eptex.ech, eptex_version.h: Change version to 150805.

2015-07-28  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* fam256.ch: Fix delcode initialization.

2015-07-10  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* eptriptest (removed): Renamed ...
	* eptriptest.test (new):  ... into this.
	* am/eptex.am: Better dependencies for 'make check'.

2015-07-06  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/eptex.am: Add libmd5.a to eptex_DEPENDENCIES.

2015-07-02  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* am/eptex.am: Add libmd5.a.
	* pdfutils.ch: Add primitive \pdfmdfivesum to e-(u)pTeX.
	* eptex.defines: Add getmd5sum().
	* eptex.ech, eptex_version.h: Change version to 150702.

2015-06-22  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/eptx.am: Use $(tie_c) and $(tie_m).

2015-04-12  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* eptrip/eptrip.diffs: Updated for TL 2015.

2014-12-12  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* eptriptest: Complain early if (e)trip.fmt is not created.
	Inspired by report from vvv, tlbuild 14 Jun 2011 10:25:47.

2014-12-10  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* eptex.ech: Fix bugs in \fontcharwd etc.
	* eptex_version.h: Change version to 141210.

2014-11-19  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* eptex.ech: Fix a bug introduced in the primitive \lastnodechar.
	* eptex_version.h: Change version to 141119.

2014-11-09  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* eptex.ech: Improve the new primitive \lastnodechar.
	* eptex_version.h: Change version to 141109.

2014-11-08  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* pdfutils.ch, eptex.ech: Add primitives \pdfshellescape and
	\lastnodechar to e-(u)ptex.
	* eptex_version.h: Change version to 141108.

2014-05-05  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>
2014-05-06  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* pdfutils.ch, eptex.defines: Add a primitive \pdffiledump for
	eptex.

2014-05-02  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* eptrip/eptrip.diffs: Updated for TL14.

2014-01-22  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* eptrip/etrip.{log,tex} (removed): Renamed ...
	* eptrip/eptrip.{log,tex} (new): ... into these.
	* eptriptest, am/eptex.am: Adapted.
	* eptrip/eptrip.{diffs,log}: Updated for e-pTeX 3.14159265.

2014-01-20  Peter Breitenlohner  <peb@mppmu.mpg.de>

	TeX tuneup of 2014.
	* eptex.ech: Adapt to TeX Version 3.14159265.

2014-01-17  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* eptrip.test (removed): Renamed ...
	* eptriptest (new): ... into this.
	* am/eptex.am: Adapted.

2013-11-21  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* eptrip/eptrip.diffs, eptrip/etrip.log: Update for etrip.tex
	Version 2.6 [2013-11-21].

2013-08-12  TANAKA Takuji <KXD02663@nifty.ne.jp>

	* eptex.defines: Allow file names with 0x5c in (e)pTeX on Windows.

2013-06-11  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Update to e-pTeX 130605 from Hironori Kitagawa.
	* eptex.ech (epTeX_version_string): 110825 => 130605.
	* pdfsavepos.ch, pdfstrcmp.ch (removed): Merged ...
	* pdfutils.ch (new): ... into this, adding some functions from
	../pdftexdir/utils.c.
	* eptex.defines: Declare the new functions.
	* am/eptex.am: Adapt.

2013-04-09  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* eptrip/eptrip.diffs, eptrip/etrip.log: Update for TL 2013.

2013-03-04  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/eptex.am: Better rule for eptex_version.h.

2013-03-01  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* eptex.ech: e-TeX Version 2.6.
	* eptrip/etrip.tex, eptrip/etrip.log: Version 2.6 [2013-03-01].
	* eptrip/eptrip.diffs: Adapt, also to fixed delcode bug.

2013-01-15  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/eptex.am, eptrip.test: Enable parallel-tests.

2012-12-16  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/eptex.am (eptex_version.h): Enable silent rules.

2012-12-01  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* fam256.ch: fix a delcode bug.

2012-09-04  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* eptexextra.h: Set AUTHOR to "Peter Breitenlohner" and
	BUG_ADDRESS to "tex-k@tug.org" (from W32TeX).

2012-08-13  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* fam256.ch: Slightly reduce one changeset to simplify e-upTeX.

2012-08-02  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* eptex.ech, eptrip/etrip.tex: Adapt to e-TeX Version 2.5.
	* am/eptex.am: Clarify *tex_version.h dependencies.

2012-07-19  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/eptex.am: Distribute eptex_version.h.
	* eptexextra.h: Use ../[ep]texdir/[ep]tex_version.h.

2012-07-15  Akira Kakuto  <kakuto@fuk.kindai.ac.jp>

	* eptexextra.c: Must #define DLLPROC before reading eptexd.h.

2012-06-30  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* eptexextra.c [W32TeX]: #define DLLPROC for eptex.dll.

2012-05-12  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* eptrip/eptrip.diffs, eptrip/etrip.log: Updated.

2012-05-11  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* eptex.ech (eTeX_version_string): Version 2.4.
	* eptrip/eptrip.diffs, eptrip/etrip.{log,tex}: Adapted.

2012-04-17  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* eptex.ech (just_copy): Bug fix, copy the additional pTeX word.
	Mail from Werner Fink <werner@suse.de>
	[tex-live] Mon, Apr 16 16:28:50.

2011-12-19  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* fam256.ch, eptex.defines: Avoid Segmentation fault for
	japanese \catcode or \kcatcode.

2011-09-30  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/eptex.am (eptexdir/ptex_version.h): Fix a typo.

2011-08-25  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* eptex.ech (just_copy): Copy the additional pTeX fields.

2011-08-18  Peter Breitenlohner  <peb@mppmu.mpg.de>

	Renamed ChangeLog => Changes.txt, ChangeLog.TL => ChangeLog.
	* am/eptex.am (EXTRA_DIST): Adapted.
	* am/eptex.am (eptex_DEPENDENCIES): Define proper dependencies.

2011-08-12  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* eptex.ech, eptexextra.h, etex.ch1, am/eptex.am, fam256.ch:
	Slightly reformulate to simplify e-upTeX.
	* pdfsavepos.ch: \pdfsavepos is extension, not convert case.

2011-07-06  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* eptex.defines: Add newline at end of file.

2011-07-04  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/eptex.am (eptex_ch_srcs): SyncTeX infrastructure.
	* pdfsavepos.ch: Slightly reformulate to simplify SyncTeX.
	* eptrip/texmf.cnf (main_memory): Increase for SyncTeX.

2011-04-15  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* eptex.ech: Adapted to pTeX Version p3.2.

2011-04-07  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* eptrip/etrip.tex, eptrip/etrip.log, eptrip/eptrip.diffs:
	Adapted to e-TeX Version 2.3.

2011-04-01  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* eptex.ech: Yet an other Bug fix.

2011-03-31  Hironori Kitagawa  <h_kitagawa2001@yahoo.co.jp>

	* eptex.ech: Bug fix and TeX formatting.
	* pdfsavepos.ch, pdfstrcmp.ch: TeX formatting.

2011-03-30  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* eptex.ech, etex.ch0: Handle disp_node from discretionary.
	Set correct last_node_type from main vertical list.

2011-03-29  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* eptex.ech, etex.ch0: Redefine box_dir and box_lr to also work
	for min_quarterword<0.

2011-03-28  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/eptex.am: Use AM_CFLAGS instead of eptex_CFLAGS.

2011-03-27  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* eptex.ech, etex.ch[01]: Reformulate @<Fetch an item in the
	current node...@>, begin_box, and delete_last to fix a bug in
	\lastpenalty & Co; further reduce e-pTeX interferences.

2011-03-25  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* eptex.ech, etex.ch[01]: Reformulate begin_box and delete_last
	to reduce interferences between e-TeX and pTeX.

	* pdfstrcmp.ch (save_warning_index): Drop unused variable.

2011-03-22  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* eptex.ech, etex.ch0: Reformulate @<Fetch an item in the
	current node...@> to reduce interferences between e-TeX and pTeX.

2011-03-18  Peter Breitenlohner  <peb@mppmu.mpg.de>

	e-pTeX update eptex-110315_tlsvn110318.diff [ptex:00248]
	from Hironori Kitagawa <h_kitagawa2001@yahoo.co.jp>.

	* eptex.ech: Update pTeX_version_string.
	Redefine box_dir and set_box_dir from pTeX as well as box_lr and
	set_box_lr from e-TeX to avoid interference.

	* pdfsavepos.ch (new): Implement \pdfsavepos primitive.
	* am/eptex.am (eptex_ch_srcs): Add pdfsavepos.ch.

	* etex.ch1: Adapt to use of set_box_dir in ../ptexdir/ptex-base.ch.
	Adapt to "setting/reading a box register dimension" bug fix.

2011-01-19  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* eptex.ech, etex.ch0: Adapt to modified ../ptexdir/ptex-base.ch.

	* eptex.ech: Make \lastnodetype consistent with e-TeX, based on
	code from Hironori Kitagawa <h_kitagawa2001@yahoo.co.jp>.

	* fam256.ch (max_reg_help_line): Use correct max_reg_num value.

2011-01-17  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* eptex.ech: banner_k==banner for e-pTeX.

	* am/eptex.am (eptrip.diffs): Use $(triptrap_diffs).

2011-01-14  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* am/eptex.am (eptrip-clean): Use TRIPTRAP_CLEAN.

2011-01-13  Peter Breitenlohner  <peb@mppmu.mpg.de>

	* eptrip.test (new): Shell script for e-pTRIP test,
	from Hironori Kitagawa <h_kitagawa2001@yahoo.co.jp>.
	* eptrip.diffs (new): Expected e-pTRIP test results.

	* eptex.ech: Increase pTeX if_*_codes above e-TeX codes.
